src/main/java/de/monticore/lang/monticar/cnnarch/caffe2generator/CNNArchTemplateController.java
/* (c) https://github.com/MontiCore/monticore */
package de.monticore.lang.monticar.cnnarch.caffe2generator;

import de.monticore.lang.monticar.cnnarch.generator.LayerNameCreator;
import de.monticore.lang.monticar.cnnarch.generator.Target;

import de.monticore.lang.monticar.cnnarch._symboltable.*;
import de.monticore.lang.monticar.cnnarch.predefined.Sigmoid;
import de.monticore.lang.monticar.cnnarch.predefined.Softmax;
import de.monticore.lang.monticar.generator.FileContent;

import java.io.StringWriter;
import java.io.Writer;
import java.util.*;

public class CNNArchTemplateController {

    public static final String FTL_FILE_ENDING = ".ftl";
    public static final String TEMPLATE_ELEMENTS_DIR_PATH = "elements/";
    public static final String TEMPLATE_CONTROLLER_KEY = "tc";
    public static final String ELEMENT_DATA_KEY = "element";

    private LayerNameCreator nameManager;
    private ArchitectureSymbol architecture;
    private String loss;

    //temporary attributes. They are set after calling process()
    private Writer writer;
    private String mainTemplateNameWithoutEnding;
    private Target targetLanguage;
    private ArchitectureElementData dataElement;

    public static final String CROSS_ENTROPY = "cross_entropy";
    public static final String EUCLIDEAN = "euclidean";

    public CNNArchTemplateController(ArchitectureSymbol architecture) {
        setArchitecture(architecture);
    }

    public String getFileNameWithoutEnding() {
        return mainTemplateNameWithoutEnding + "_" + getFullArchitectureName();
    }

    public ArchitectureElementData getCurrentElement() {
        return dataElement;
    }

    public void setCurrentElement(ArchitectureElementSymbol layer) {
        this.dataElement = new ArchitectureElementData(getName(layer), layer, this);
    }

    public void setCurrentElement(ArchitectureElementData dataElement) {
        this.dataElement = dataElement;
    }

    public ArchitectureSymbol getArchitecture() {
        return architecture;
    }

    public void setArchitecture(ArchitectureSymbol architecture) {
        this.architecture = architecture;
        this.nameManager = new LayerNameCreator(architecture);
    }

    public String getName(ArchitectureElementSymbol layer){
        return nameManager.getName(layer);
    }

    public String getArchitectureName(){
        return getArchitecture().getEnclosingScope().getSpanningSymbol().get().getName().replaceAll("\\.","_");
    }

    public String getFullArchitectureName(){
        return getArchitecture().getEnclosingScope().getSpanningSymbol().get().getFullName().replaceAll("\\.","_");
    }

    public String getDataPath(){
        return getArchitecture().getDataPath();
    }


    public List<String> getLayerInputs(ArchitectureElementSymbol layer){
        List<String> inputNames = new ArrayList<>();

        if (isSoftmaxOutput(layer) || isLogisticRegressionOutput(layer)){
            inputNames = getLayerInputs(layer.getInputElement().get());
        } else {
            for (ArchitectureElementSymbol input : layer.getPrevious()) {
                if (input.getOutputTypes().size() == 1) {
                    inputNames.add(getName(input));
                } else {
                    for (int i = 0; i < input.getOutputTypes().size(); i++) {
                        inputNames.add(getName(input) + "[" + i + "]");
                    }
                }
            }
        }
        return inputNames;

    }

    public List<String> getArchitectureInputs(){
        List<String> list = new ArrayList<>();
        for (VariableSymbol element : getArchitecture().getInputs()){
            list.add(nameManager.getName(element));
        }
        return list;
    }

    public List<String> getArchitectureOutputs(){
        List<String> list = new ArrayList<>();
        for (VariableSymbol element : getArchitecture().getOutputs()){
            list.add(nameManager.getName(element));
        }
        return list;
    }

    public String getComponentName(){
        return getArchitecture().getComponentName();
    }

    public String getArchitectureLoss(){
        return this.loss;
    }

    public void include(String relativePath, String templateWithoutFileEnding, Writer writer){
        String templatePath = relativePath + templateWithoutFileEnding + FTL_FILE_ENDING;
        Map<String, Object> ftlContext = new HashMap<>();
        ftlContext.put(TEMPLATE_CONTROLLER_KEY, this);
        ftlContext.put(ELEMENT_DATA_KEY, getCurrentElement());
        TemplateConfiguration.processTemplate(ftlContext, templatePath, writer);
    }

    public void include(VariableSymbol element, Writer writer){
        ArchitectureElementData previousElement = getCurrentElement();
        setCurrentElement(element);

        if (element.isAtomic()){
            if (element.isInput()){
                include(TEMPLATE_ELEMENTS_DIR_PATH, "Input", writer);
            } else {
                include(TEMPLATE_ELEMENTS_DIR_PATH, "Output", writer);
            }
        } else {
            include((ArchitectureElementSymbol) element.getResolvedThis().get(), writer);
        }

        setCurrentElement(previousElement);
    }

    public void include(LayerSymbol layer, Writer writer){
        ArchitectureElementData previousElement = getCurrentElement();
        setCurrentElement(layer);

        if (layer.isAtomic()){
            ArchitectureElementSymbol nextElement = layer.getOutputElement().get();
            if (!isSoftmaxOutput(nextElement) && !isLogisticRegressionOutput(nextElement)){
                String templateName = layer.getDeclaration().getName();
                include(TEMPLATE_ELEMENTS_DIR_PATH, templateName, writer);
            }
        } else {
            include((ArchitectureElementSymbol) layer.getResolvedThis().get(), writer);
        }

        setCurrentElement(previousElement);
    }

    public void include(CompositeElementSymbol compositeElement, Writer writer){
        ArchitectureElementData previousElement = getCurrentElement();
        setCurrentElement(compositeElement);

        for (ArchitectureElementSymbol element : compositeElement.getElements()){
            include(element, writer);
        }

        setCurrentElement(previousElement);
    }

    public void include(ArchitectureElementSymbol architectureElement, Writer writer){
        if (architectureElement instanceof CompositeElementSymbol){
            include((CompositeElementSymbol) architectureElement, writer);
        } else if (architectureElement instanceof LayerSymbol){
            include((LayerSymbol) architectureElement, writer);
        } else {
            include((VariableSymbol) architectureElement, writer);
        }
    }

    public void include(ArchitectureElementSymbol architectureElement){
        if (writer == null){
            throw new IllegalStateException("missing writer");
        }
        include(architectureElement, writer);
    }

    public FileContent process(String templateNameWithoutEnding, Target targetLanguage) {
        StringWriter newWriter = new StringWriter();
        this.mainTemplateNameWithoutEnding = templateNameWithoutEnding;
        this.targetLanguage = targetLanguage;
        this.writer = newWriter;
        this.include("", templateNameWithoutEnding, newWriter);
        String fileEnding = targetLanguage.toString();
        String fileName = this.getFileNameWithoutEnding() + fileEnding;
        FileContent fileContent = new FileContent(newWriter.toString(), fileName);
        this.mainTemplateNameWithoutEnding = null;
        this.targetLanguage = null;
        this.writer = null;
        return fileContent;
    }

    public String join(Iterable iterable, String separator){
        return join(iterable, separator, "", "");
    }

    public String join(Iterable iterable, String separator, String elementPrefix, String elementPostfix){
        StringBuilder stringBuilder = new StringBuilder();
        boolean isFirst = true;
        for (Object element : iterable){
            if (!isFirst){
                stringBuilder.append(separator);
            }
            stringBuilder.append(elementPrefix);
            stringBuilder.append(element.toString());
            stringBuilder.append(elementPostfix);
            isFirst = false;
        }
        return stringBuilder.toString();
    }


    public boolean isLogisticRegressionOutput(ArchitectureElementSymbol architectureElement){
        if (isTOutput(Sigmoid.class, architectureElement)){
            this.loss = CROSS_ENTROPY;
            return true;
        }
        return false;
    }

    public boolean isLinearRegressionOutput(ArchitectureElementSymbol architectureElement){
        if (architectureElement.isOutput()
                && !isLogisticRegressionOutput(architectureElement)
                && !isSoftmaxOutput(architectureElement)){
            this.loss = EUCLIDEAN;
            return true;
        }
        return false;
    }


    public boolean isSoftmaxOutput(ArchitectureElementSymbol architectureElement){
        if (isTOutput(Softmax.class, architectureElement)){
            this.loss = CROSS_ENTROPY;
            return true;
        }
        return false;
    }

    private boolean isTOutput(Class inputPredefinedLayerClass, ArchitectureElementSymbol architectureElement){
        if (architectureElement.isOutput()
                && architectureElement.getInputElement().isPresent()
                && architectureElement.getInputElement().get() instanceof LayerSymbol){
            LayerSymbol inputLayer = (LayerSymbol) architectureElement.getInputElement().get();
            if (inputPredefinedLayerClass.isInstance(inputLayer.getDeclaration())){
                return true;
            }
        }
        return false;
    }
}

src/main/resources/templates/caffe2/CNNDataCleaner.ftl
<#-- (c) https://github.com/MontiCore/monticore -->
<#-- So that the license is in the generated file: -->
# (c) https://github.com/MontiCore/monticore
import gc, os
import h5py
import numpy as np
import random
from skimage.transform import rotate, rescale
import cv2

# import for caffe2
import cv2
from caffe2.proto import caffe2_pb2
from caffe2.python import (
    workspace,
    brew,
    core
)

class ${tc.fileNameWithoutEnding}:

    def __init__(self):
        self._current_dir_ = os.path.join('./')

    
    # ------ cleaning algorithm ------
    def clean_data(self, data, label, cleaning, cleaning_param):
        cleaning_params = dict(cleaning_param)

        # begin identifying indeces of np array to be removed 
        ## with missing 
        missing, noisy = self.get_dirty(data, label, cleaning_params)
       
        # remove elements by identified indices
        indices = np.append(missing, noisy).astype(int)
        if np.any(indices):
            data = np.delete(data, indices, axis=0)
            label = np.delete(label, indices, axis=0)

        # remove unused arrays from memory
        del missing, noisy, indices
        gc.collect()

        ## unique values
        unique = []
        if cleaning_params['duplicate']:
            unique = self.get_unique(data, label)
        
        if np.any(unique):
            data = np.take(data, unique, axis=0)
            label = np.take(label, unique, axis=0)

        return data, label

    # ------ helper functions for data cleaning ------
    def get_dirty(self, data, label, params):
        missing, noisy = [], []
        if params['missing']:
            """idenfify indeces of missing values"""
            # missing values (e.g., nan in data or label)
            missing = np.concatenate((
                np.unique(np.where(np.isnan(np.squeeze(data, axis=1)).all(axis=2))[0]), 
                np.where(np.isnan(label))[0]
            ),axis=0)
            missing = np.sort(missing)
        
        if params['noisy']:
            """idenfify indeces of faulty values"""
            # faulty values (e.g. empty images or labels outside range between [0,9])
            noisy = np.concatenate((
                np.where([(data[i][0] == 0).all() for i in range(len(data))])[0],
                np.where(label < 0)[0], 
                np.where(label > 9)[0]
            ),axis=0)
            noisy = np.sort(noisy)
        
        return missing, noisy


    def get_unique(self, data, label):
        """idenfify indeces of unique values"""
        arr = [tuple(row) for row in data]
        _, indx = np.unique(arr, axis=0, return_index = True)
        return np.sort(indx, axis=None) 


    # ------ data imbalance upsampling algorithm ------
    def image_augmentation(self, data, label, data_imbalance, params): 
        _, counts = np.unique(label, return_counts=True)    # identify counts of every label
        median = int(np.median(counts))
        minority_label = np.where(counts < median-median/4)[0]

        if np.any(np.asarray(minority_label)):
            new_data, new_label = [], []
            # start data augmentation for every minority label
            for minority_class in minority_label:
                aug_indx = np.where(label == minority_class)[0]
                random.shuffle(aug_indx)
                iter = 0
                for i in aug_indx:
                    img = data[i][0]
                    if params['rotation_angle'] != None or params['rotation_angle'] != []:
                        for a in params['rotation_angle']: # rotation degrees
                            rotated = rotate(img,angle=a)  # shape in/out: (28,28)
                            new_data.append(np.reshape(rotated, (1,) + rotated.shape))
                            new_label.append(minority_class)
                            iter += 1

                    if params['shift']:
                        dict = {   # shift image up, down, left, right
                            (0,random.randint(1,4)): 'up',
                            (0,-random.randint(1,4)): 'down',
                            (-random.randint(1,4),0): 'left',
                            (random.randint(1,4),0): 'right' 
                        }
                        for key in dict:
                            shifted = cv2.warpAffine(img, np.float32([ [1,0,key[0]], [0,1,key[1]] ]), (28,28))  # shape in/out: (28,28)
                            new_data.append(np.reshape(shifted, (1,) + shifted.shape))
                            new_label.append(minority_class)
                            iter += 1

                    if params['scale_out']:
                        # rescale out
                        scale_fct = round(random.uniform(0.7, 0.9), 2)
                        scale_out = rescale(img, scale=scale_fct, mode='constant')
                        scale_out = cv2.warpAffine( 
                                scale_out, 
                                cv2.getRotationMatrix2D( (scale_out.shape[1],scale_out.shape[0]), 0, scale_fct), # shape in/out: (28,28)
                                (28,28)
                        )    
                        new_data.append(np.reshape(scale_out, (1,) + scale_out.shape))
                        new_label.append(minority_class)
                        iter += 1

                    if params['scale_in']:
                        # rescale in 
                        scale_fct = round(random.uniform(1.05, 1.1), 2)
                        scale_in = rescale(img, scale=scale_fct, mode='constant')
                        scale_in = cv2.warpAffine( 
                                scale_in, 
                                cv2.getRotationMatrix2D( (scale_in.shape[1],scale_in.shape[0]), 0, scale_fct), # shape in/out: (28,28)
                                (28,28)
                        ) 
                        new_data.append(np.reshape(scale_in, (1,) + scale_in.shape))
                        new_label.append(minority_class)
                        iter += 1
                    
                    # check if already enough new generated img
                    if iter >= int(median-(counts[minority_class])):
                        break

            if np.any(np.asarray(new_data)):
                data = np.concatenate((data, np.asarray(new_data)), axis=0)
                label = np.concatenate((label, np.asarray(new_label)), axis=0)
        
        return data, label


    def check_bias(self, data, label, model_dir, opts):
        # Reset workspace and load model
        workspace.ResetWorkspace(os.path.join('/opt'))
        init_def = caffe2_pb2.NetDef()
        with open(model_dir+'/init_net.pb', 'rb') as f:
            init_def.ParseFromString(f.read())
            init_def.device_option.CopyFrom(opts)
            workspace.RunNetOnce(init_def.SerializeToString())
    
        net_def = caffe2_pb2.NetDef()
        with open(model_dir+'/predict_net.pb', 'rb') as f:
            net_def.ParseFromString(f.read())
            net_def.device_option.CopyFrom(opts)
            workspace.CreateNet(net_def.SerializeToString(), overwrite=True)

        # calculate confusion matrix
        CM = np.zeros((10,10), dtype=int)
        for t in range(len(data)):
            i = label[t]
            input = data[t].reshape((1,1,28,28)).astype('float32')   # reshape to (1,1,28,28)
            workspace.FeedBlob("data", input, device_option=opts)       # FeedBlob
            workspace.RunNet('deploy_net', num_iter=1)                  # Forward
            j = np.argmax(workspace.FetchBlob("softmax_"))
        
            CM[i][j] += 1

        # check number of matrix dimensions
        sum_col = np.sum(CM, axis=0, dtype=np.int32)
        sum_row = np.sum(CM, axis=1, dtype=np.int32)
        if(np.sum(sum_col) != np.sum(sum_col)):
            print("Error: Sum of actual label and sum of predicted label is different in Confusion Matrix!")

        # start Bias Checking
        TP = CM.diagonal()
        
        TPR = np.zeros((10), dtype=float)
        for c in range(10):
            TPR[c] = np.round(CM[c][c] / (CM[c][c] + sum([CM[c][i] for i in range(0,10) if i != c])),4)

        FPR = np.zeros((10), dtype=float)
        for c in range(10):
            FP = sum([CM[i][c] for i in range(0,10) if i != c])
            FPR[c] = np.round(FP / (FP + sum([CM[i][j] for i in range(0,10) for j in range(0,10) if i != c])),4)

        # show results
        print('\n--------- Check Model Bias: --------------------------------------------------\n')
        
        print('TP:' + np.array2string(TP))
        print('TPR:' + np.array2string(TPR))
        print('FPR:' + np.array2string(FPR))

        print('\n\tSatisfy Multi-class Demographic Parity \t...... ' + str(np.all(np.isclose(TP, TP[0]))))
        print('\tSatisfy Multi-class Equality of Odds \t...... ' + str(np.all(np.isclose(TPR, TPR[0])) and np.all(np.isclose(FPR, FPR[0]))))
        print('\tSatisfy Multi-class Equal Opportunity \t...... ' + str(np.all(np.isclose(TPR, TPR[0]))))

        print('\n------------------------------------------------------------------------------')

        
    

src/main/resources/templates/caffe2/CNNPredictor.ftl
<#-- (c) https://github.com/MontiCore/monticore -->
<#-- So that the license is in the generated file: -->
/* (c) https://github.com/MontiCore/monticore */
#ifndef ${tc.fileNameWithoutEnding?upper_case}
#define ${tc.fileNameWithoutEnding?upper_case}

#include "caffe2/core/common.h"
#include "caffe2/utils/proto_utils.h"
#include "caffe2/core/workspace.h"
#include "caffe2/core/tensor.h"
#include "caffe2/core/init.h"

// Define USE_GPU for GPU computation. Default is CPU computation.
//#define USE_GPU

#ifdef USE_GPU
#include "caffe2/core/context_gpu.h"
#endif

#include <string>
#include <iostream>
#include <map>

CAFFE2_DEFINE_string(init_net_${tc.fileNameWithoutEnding}, "./model/${tc.componentName}/init_net.pb", "The given path to the init protobuffer.");
CAFFE2_DEFINE_string(predict_net_${tc.fileNameWithoutEnding}, "./model/${tc.componentName}/predict_net.pb", "The given path to the predict protobuffer.");

using namespace caffe2;

class ${tc.fileNameWithoutEnding}_0{
    private:
        TensorCPU input;
        Workspace workSpace;
        NetDef initNet, predictNet;

    public:
        const std::vector<TIndex> input_shapes = {<#list tc.architecture.inputs as input>{1,${tc.join(input.ioDeclaration.type.dimensions, ",")}}<#if input?has_next>,</#if></#list>};

        explicit ${tc.fileNameWithoutEnding}_0(){
            init(input_shapes);
        }

        ~${tc.fileNameWithoutEnding}_0(){};

        void init(const std::vector<TIndex> &input_shapes){
            int n = 0;
            char **a[1];
            caffe2::GlobalInit(&n, a);

            if (!std::ifstream(FLAGS_init_net_${tc.fileNameWithoutEnding}).good()) {
                std::cerr << "\nNetwork loading failure, init_net file '" << FLAGS_init_net_${tc.fileNameWithoutEnding} << "' does not exist." << std::endl;
                exit(1);
            }

            if (!std::ifstream(FLAGS_predict_net_${tc.fileNameWithoutEnding}).good()) {
                std::cerr << "\nNetwork loading failure, predict_net file '" << FLAGS_predict_net_${tc.fileNameWithoutEnding} << "' does not exist." << std::endl;
                exit(1);
            }

            std::cout << "\nLoading network..." << std::endl;

            // Read protobuf
            CAFFE_ENFORCE(ReadProtoFromFile(FLAGS_init_net_${tc.fileNameWithoutEnding}, &initNet));
            CAFFE_ENFORCE(ReadProtoFromFile(FLAGS_predict_net_${tc.fileNameWithoutEnding}, &predictNet));

            // Set device type
            #ifdef USE_GPU
            predictNet.mutable_device_option()->set_device_type(CUDA);
            initNet.mutable_device_option()->set_device_type(CUDA);
            std::cout << "== GPU mode selected " << " ==" << std::endl;
            #else
            predictNet.mutable_device_option()->set_device_type(CPU);
            initNet.mutable_device_option()->set_device_type(CPU);

            for(int i = 0; i < predictNet.op_size(); ++i){
                predictNet.mutable_op(i)->mutable_device_option()->set_device_type(CPU);
            }
            for(int i = 0; i < initNet.op_size(); ++i){
                initNet.mutable_op(i)->mutable_device_option()->set_device_type(CPU);
            }
            std::cout << "== CPU mode selected " << " ==" << std::endl;
            #endif

            // Load network
            CAFFE_ENFORCE(workSpace.RunNetOnce(initNet));
            CAFFE_ENFORCE(workSpace.CreateNet(predictNet));
            std::cout << "== Network loaded " << " ==" << std::endl;

            input.Resize(input_shapes);
        }

        void predict(${tc.join(tc.architectureInputs, ", ", "const std::vector<float> &", "")}, ${tc.join(tc.architectureOutputs, ", ", "std::vector<float> &", "")}){
            //Note: ShareExternalPointer requires a float pointer.
            input.ShareExternalPointer((float *) ${tc.join(tc.architectureInputs, ",", "","")}.data());

            // Get input blob
            #ifdef USE_GPU
            auto dataBlob = workSpace.GetBlob("data")->GetMutable<TensorCUDA>();
            #else
            auto dataBlob = workSpace.GetBlob("data")->GetMutable<TensorCPU>();
            #endif

            // Copy from input data
            dataBlob->CopyFrom(input);

            // Forward
            workSpace.RunNet(predictNet.name());

            // Get output blob
<#list tc.architectureOutputs as outputName>
            #ifdef USE_GPU
            auto ${outputName + "Blob"} = TensorCPU(workSpace.GetBlob("${outputName?keep_before_last("_")}")->Get<TensorCUDA>());
            #else
            auto ${outputName + "Blob"} = workSpace.GetBlob("${outputName?keep_before_last("_")}")->Get<TensorCPU>();
            #endif
            ${outputName}.assign(${outputName + "Blob"}.data<float>(),${outputName + "Blob"}.data<float>() + ${outputName + "Blob"}.size());

</#list>
            google::protobuf::ShutdownProtobufLibrary();
        }
};

#endif // ${tc.fileNameWithoutEnding?upper_case}

src/main/resources/templates/caffe2/CNNTrainer.ftl
<#-- (c) https://github.com/MontiCore/monticore -->
<#-- So that the license is in the generated file: -->
# (c) https://github.com/MontiCore/monticore
<#setting number_format="computer">
from caffe2.python import workspace, core, model_helper, brew, optimizer
from caffe2.python.predictor import mobile_exporter
from caffe2.proto import caffe2_pb2

import numpy as np
import logging
<#list configurations as config>
import CNNCreator_${config.instanceName}
import CNNDataCleaner_${config.instanceName}
</#list>

if __name__ == "__main__":
    logging.basicConfig(level=logging.DEBUG)
    logger = logging.getLogger()
    handler = logging.FileHandler("train.log", "w", encoding=None, delay="true")
    logger.addHandler(handler)

<#list configurations as config>
    ${config.instanceName}_cleaner = CNNDataCleaner_${config.instanceName}.CNNDataCleaner_${config.instanceName}()
    ${config.instanceName} = CNNCreator_${config.instanceName}.CNNCreator_${config.instanceName}(
        ${config.instanceName}_cleaner
    )
    ${config.instanceName}.train(
    <#if (config.numEpoch)??>
        num_epoch=${config.numEpoch},
    </#if>
    <#if (config.batchSize)??>
        batch_size=${config.batchSize},
    </#if>
    <#if (config.context)??>
        context='${config.context}',
    </#if>
    <#if (config.cleaning)??>
        cleaning='${config.cleaningName}',
        cleaning_params={
        <#if (config.cleaningParameters)??>
        <#list config.cleaningParameters?keys as param>
            '${param}': ${config.cleaningParameters[param]}<#sep>,
        </#list>
        </#if>
        },
    </#if>
    <#if (config.dataImbalance)??>
        data_imbalance='${config.dataImbalanceName}',
        data_imbalance_params={
        <#if (config.dataImbalanceParameters)??>
        <#list config.dataImbalanceParameters?keys as param>
            '${param}': ${config.dataImbalanceParameters[param]}<#sep>,
        </#list>
        </#if>
        },
    </#if>
    <#if (config.evalMetric)??>
        eval_metric='${config.evalMetricName}',
    </#if>
    <#if (config.loss)??>
        loss='${config.lossName}',
    </#if>
    <#if (config.optimizer)??>
        opt_type='${config.optimizerName}'<#if config.optimizerParameters?has_content>,
        <#list config.optimizerParameters?keys as param>
        <#--To adapt parameter names to Caffe2 since they are different than in CNNTrainLang-->
        <#assign paramName = param>
        <#assign paramValue = config.optimizerParameters[param]>
        <#if param == "learning_rate">
            <#assign paramName = "base_learning_rate">
        <#elseif param == "learning_rate_policy">
            <#assign paramName = "policy">
            <#assign paramValue = "'${paramValue}'">
        <#elseif param == "step_size">
            <#assign paramName = "stepsize">
        <#elseif param == "gamma1">
            <#assign paramName = "gamma1">
        <#elseif param == "learning_rate_decay">
            <#assign paramName = "gamma">
        </#if>
            ${paramName}=${paramValue}<#sep>,
        </#list>
    </#if>
    </#if>

    )
</#list>

src/main/resources/templates/caffe2/execute.ftl
<#-- (c) https://github.com/MontiCore/monticore -->
<#list tc.architecture.outputs as output>
    <#assign shape = output.ioDeclaration.type.dimensions>
    vector<float> CNN_${tc.getName(output)}(<#list shape as dim>${dim?c}<#if  dim?has_next>*</#if></#list>);
</#list>

    _predictor_0_.predict(<#list tc.architecture.inputs as input>CNNTranslator::translate(${input.name}<#if input.arrayAccess.isPresent()>[${input.arrayAccess.get().intValue.get()?c}]</#if>),
                </#list><#list tc.architecture.outputs as output>CNN_${tc.getName(output)}<#if output?has_next>,
                </#if></#list>);

<#list tc.architecture.outputs as output>
<#assign shape = output.ioDeclaration.type.dimensions>
<#if shape?size == 1>
    ${output.name}<#if output.arrayAccess.isPresent()>[${output.arrayAccess.get().intValue.get()?c}]</#if> = CNNTranslator::translateToCol(CNN_${tc.getName(output)}, std::vector<size_t> {${shape[0]?c}});
</#if>
<#if shape?size == 2>
    ${output.name}<#if output.arrayAccess.isPresent()>[${output.arrayAccess.get().intValue.get()?c}]</#if> = CNNTranslator::translateToMat(CNN_${tc.getName(output)}, std::vector<size_t> {${shape[0]?c}, ${shape[1]?c}});
</#if>
<#if shape?size == 3>
    ${output.name}<#if output.arrayAccess.isPresent()>[${output.arrayAccess.get().intValue.get()?c}]</#if> = CNNTranslator::translateToCube(CNN_${tc.getName(output)}, std::vector<size_t> {${shape[0]?c}, ${shape[1]?c}, ${shape[2]?c}});
</#if>
</#list>